/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  asm.P
  Author(s)		:  Saumya Debray, Terrance Swift, Jiyang Xu
  Last modification	:  July  1992
========================================================================*/


asm_inst(label(_T,_X),		0,	-2,	[]).
asm_inst(getpvar(V,R),		4,	0,	[p, v(V), r(R)]	).
asm_inst(getpval(V,R),		4,	1,	[p, v(V), r(R)]	).
asm_inst(getstrv(V,I),		8,	2,	[pp, v(V), s(I)]).
asm_inst(gettval(R,R1),		4,	3,	[p, r(R), r(R1)]).
asm_inst(getcon(R,I),		8,	4,	[pp, r(R), c(I)]).
asm_inst(getnil(R),		4,	5,	[pp, r(R)]	). 
asm_inst(getstr(R,I),		8,	6,	[pp, r(R), s(I)]).
asm_inst(getlist(R),		4,	7,	[pp, r(R)]	).
asm_inst(unipvar(V),		4,	8,	[pp, v(V)]	).
asm_inst(unipval(V),		4,	9,	[pp, v(V)]	).
asm_inst(unitvar(R),		4,	10,	[pp, r(R)]	).
asm_inst(unitval(R),		4,	11,	[pp, r(R)]	).
asm_inst(unicon(I),		8,	12,	[ppp, c(I)]	). 
asm_inst(uninil,		4,	13,	[ppp]		).
asm_inst(getnumcon(R,N),	8,	14,	[pp, r(R), n(N)]).
asm_inst(putnumcon(R,N),	8,	15,	[pp, r(R), n(N)]).
asm_inst(putpvar(V,R),		4,	16,	[p, v(V), r(R)]	).
asm_inst(putpval(V,R),		4,	17, 	[p, v(V), r(R)]	).
asm_inst(puttvar(R,R1),		4,	18,	[p, r(R), r(R1)]).
asm_inst(putstrv(V,I),		8,	19,	[pp, v(V), s(I)]).
asm_inst(putcon(R,I),		8,	20,	[pp, r(R), c(I)]).
asm_inst(putnil(R),		4,	21,	[pp, r(R)]	).
asm_inst(putstr(R,I),		8,	22,	[pp, r(R), s(I)]).
asm_inst(putlist(R),		4,	23,	[pp, r(R)]	).
asm_inst(bldpvar(V),		4,	24,	[pp, v(V)]	).
asm_inst(bldpval(V),		4,	25,	[pp, v(V)]	).
asm_inst(bldtvar(R),		4,	26,	[pp, r(R)]	).
asm_inst(bldtval(R),		4,	27,	[pp, r(R)]	).
asm_inst(bldcon(I),		8,	28,	[ppp, c(I)]	).
asm_inst(bldnil,		4,	29,	[ppp]		).
asm_inst(uninumcon(N),		8,	30,	[ppp, n(N)]	). 
asm_inst(bldnumcon(N),		8,	31,	[ppp, n(N)]	).
asm_inst(getlist_tvar_tvar(R0,R1,R2), 4,72,	[r(R0), r(R1), r(R2)]	).
asm_inst(getcomma(R),		4,	73,	[pp, r(R)]	).
asm_inst(getcomma_tvar_tvar(R0,R1,R2),4,74,	[r(R0), r(R1), r(R2)]	).
asm_inst(getfloat(R,Float),	8,	128,	[pp, r(R), n(Float)]	).
asm_inst(putfloat(R,Float),	8,	129,	[pp, r(R), n(Float)]	).
asm_inst(unifloat(Float),	8,	130,	[ppp, n(Float)]	).
asm_inst(bldfloat(Float),	8,	131,	[ppp, n(Float)]	).
asm_inst(trys(A,L),		8,	154,	[pp, a(A), l(L)]).
asm_inst(retrys(A,L),		8,	155,	[pp, a(A), l(L)]).
asm_inst(trusts(A,L),		8,	156,	[pp, a(A), l(L)]).
asm_inst(neck(A),		4,	157,	[pp, a(A)]	).
asm_inst(neck_putpbreg(A,V),	4,	158,	[p, a(A), v(V)]	).
asm_inst(neck_puttbreg(A,R),	4,	159,	[p, a(A), r(R)]	).
asm_inst(trymeelse(A,L),	8,	160,	[pp, a(A), l(L)]).
asm_inst(retrymeelse(A,L),	8,	161,	[pp, a(A), l(L)]).
asm_inst(trustmeelsefail(A),	4,	162,	[pp, a(A)]	).
asm_inst(try(A,L),		8,	163,	[pp, a(A), l(L)]).
asm_inst(retry(A,L),		8,	164,	[pp, a(A), l(L)]).
asm_inst(trust(A,L),		8,	165,	[pp, a(A), l(L)]).
asm_inst(getpbreg(V),		4,	166,	[pp, v(V)]	).
asm_inst(gettbreg(R),		4,	167,	[pp, r(R)]	).
asm_inst(putpbreg(V),		4,	168,	[pp, v(V)]	).
asm_inst(puttbreg(R),		4,	169,	[pp, r(R)]	).
asm_inst(jumpsavebreg(A,L),	8,	170,	[pp, a(A),l(L)]	).
asm_inst(getstring(R,String),	8,	172,	[pp, r(R), g(String)]	).
asm_inst(putstring(R,String),	8,	173,	[pp, r(R), g(String)]	).
asm_inst(unistring(String),	8,	174,	[ppp, g(String)]).
asm_inst(bldstring(String),	8,	175,	[ppp, g(String)]).
asm_inst(switchonterm(R,L,L1),	12,	176,	[pp, r(R), l(L), l(L1)]	).
/* the following two instructions have not been implemented by Jiyang or TLS */
asm_inst(switchoncon(L),	8,	177,	[ppp, l(L)]	).
asm_inst(switchonstr(L),	8,	178,	[ppp, l(L)]	).
asm_inst(switchonbound(R, L, N), 12,	179,	[pp, r(R), i(L), i(N)]	).
asm_inst(switchon3bound(R1, R2, R3, L, N),
			12,	180,	[r(R1), r(R2), r(R3), i(L), i(N)] ).
	% label is preprocessed
asm_inst(partry(A,N),		8,	183,	[pp, a(A), n(N)]).
/* asm_inst(terminate,		4,	184,	[ppp]		).
  not used in compiler */

asm_inst(dyntrustmeelsefail(A,L),	8,	186,	[pp, a(A), l(L)]).

asm_inst(tableretry(A,L),	8,	189,	[pp, a(A), l(L)]).
asm_inst(tabletry(A,L,Tbind),   12,     190,    [pp, a(A),l(L),i(Tbind)]  ).
asm_inst(addtotable(Arity,Reg), 4,     	191,    [p,a(Arity),r(Reg)]  ).
asm_inst(tabletrust(A,L), 	8,     	193,    [pp, a(A),l(L)]  ).
asm_inst(tabconfig(Chs,Rhs), 	0,    	194,    [ppp, i(Chs),i(Rhs)]  ).
asm_inst(complete_call(S,B),	8,     	195,	[pp, a(B), s(S)]).
asm_inst(comptabletry(A,L,Tbi), 12,    	196,    [pp, a(A),l(L),i(Tbi)]  ).
asm_inst(tabletryfail(A,L,Tbi),	12,    197,	[pp, a(A),l(L),i(Tbi)]  ).
asm_inst(comptabletryfail(A,L,Tbi),12,    198,	[pp, a(A),l(L),i(Tbi)]  ).
asm_inst(complete_execute(S),   8,	203,	[ppp, s(S)]	).

asm_inst(movreg(R,R1),		4,	209,	[p, r(R), r(R1)]).
asm_inst(negate(R),		4,	210,	[pp, r(R)]	).
asm_inst(and(R,R1),		4,	211,	[p, r(R), r(R1)]).
asm_inst(or(R,R1),		4,	212,	[p, r(R), r(R1)]).
asm_inst(logshiftl(R,R1),	4,	213,	[p, r(R), r(R1)]).
asm_inst(logshiftr(R,R1),	4,	214,	[p, r(R), r(R1)]).
asm_inst(addreg(R,R1),		4,	215,	[p, r(R), r(R1)]).
asm_inst(subreg(R,R1),		4,	216,	[p, r(R), r(R1)]).
asm_inst(mulreg(R,R1),		4,	217,	[p, r(R), r(R1)]).
asm_inst(divreg(R,R1),		4,	218,	[p, r(R), r(R1)]).
asm_inst(idivreg(R,R1),		4,	219,	[p, r(R), r(R1)]).
asm_inst(putdval(V,R),		4,	224,	[p, v(V), r(R)]	).
asm_inst(putuval(V,R),		4,	225,	[p, v(V), r(R)]	).
asm_inst(call(S,B),		8,	232,	[pp, a(B), s(S)]).
	% Address hass been preprocessed
asm_inst(allocate,		4,	233,	[ppp]		).
asm_inst(deallocate,		4,	234,	[ppp]		).
asm_inst(proceed,		4,	235,	[ppp]		).
asm_inst(execute(S),		8,	236,	[ppp, s(S)]	).
	% Address has been preprocessed
% asm_inst(executev,		4,	-1,	[ppp]		).
asm_inst(calld(L,B),		8,	239,	[pp, a(B), n(L)]).
	% not used by the compiler; Address has been preprocessed
asm_inst(executed(I),		8,	240,	[ppp, n(I)]	).
	% only used in assembler; executed = jump except addr is preprocessed
asm_inst(jump(L),		8,	240,	[ppp, l(L)]	).
asm_inst(jumpz(R,L),		8,	241,	[pp, r(R),  l(L)]).
asm_inst(jumpnz(R,L),		8,	242,	[pp, r(R),  l(L)]).
asm_inst(jumplt(R,L),		8,	243,	[pp, r(R),  l(L)]).
asm_inst(jumple(R,L),		8,	244,	[pp, r(R),  l(L)]).
asm_inst(jumpgt(R,L),		8,	245,	[pp, r(R),  l(L)]).
asm_inst(jumpge(R,L),		8,	246,	[pp, r(R),  l(L)]).
asm_inst(cases(A,I,N),		10,	247,	[a(A), n(I), n(N)]	). 
	% only used in index block
asm_inst(fail,			4,	248,	[ppp]		).
asm_inst(noop(A),		4,	249,	[pp, a(A)]	).
asm_inst(halt,			4,	250,	[ppp]		).
asm_inst(builtin(W),		4,	251,	[pp, a(W)]	).
asm_inst(unifunc(W,R),		4,	252,	[p, a(W), r(R)]	).
%  asm_inst(straight_noop,	4,	252,	[ppp]		).
asm_inst(userfunc(A,I),		8,	253,	[pp, a(A), s(I)]).
asm_inst(arglabel(T, I, L),	9,	-3,	[t(T), n(I), l(L)]	).
	% only used in index block
asm_inst(arglabel(T, L),	5,	-3,	[t(T), l(L)]	).
	% only used in index block
%  asm_inst(modname(_p), 	0,	-1,	[]).
asm_inst(endfile(_P,_A),		8,	255,	[ppp, n(0)]	).

force_asm_inst_loaded.
