/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  builtin.P
  Author(s)		:  Saumya Debray, Kostis F. Sagonas
  Modified by		:  Kostis F. Sagonas
  Last modification	:  May 21, 1993
========================================================================*/


/*======================================================================*/
/* inline predicates							*/
/*======================================================================*/

inline_predicate('=', 2).
inline_predicate('<', 2).
inline_predicate('>', 2).
inline_predicate('=<', 2).
inline_predicate('>=', 2).
inline_predicate('=:=', 2).
inline_predicate('=\=', 2).
inline_predicate(is, 2).
inline_predicate(fail, 0).
inline_predicate(true, 0).
inline_predicate(halt, 0).
inline_predicate(var, 1).
inline_predicate(nonvar, 1).
inline_predicate('!', 0).
inline_predicate('_$cutto', 1).
inline_predicate('_$savecp', 1).
inline_predicate('_$builtin', 1).
inline_predicate('_$return', 1).	% used for functions
inline_predicate('_$getreturn', 1).	% used for functions

/*======================================================================*/
/* primitive predicates	("hard-wired" builtins)				*/
/*======================================================================*/

inline_builtin(psc_name, 2, 1).
inline_builtin(psc_arity, 2, 2).
inline_builtin(psc_type, 2, 3).
inline_builtin(psc_prop, 2, 4).
inline_builtin(psc_set_type, 3, 5).
inline_builtin(psc_set_prop, 3, 6).
inline_builtin(file_open, 3, 7).
inline_builtin(file_close, 1, 8).
inline_builtin(file_get, 2, 9).
inline_builtin(file_put, 2, 10).
inline_builtin(term_psc, 2, 11).
inline_builtin(term_type, 2, 12).
inline_builtin(term_compare, 3, 13).
inline_builtin(term_new, 2, 14).
inline_builtin(term_arg, 3, 15).
inline_builtin(term_set_arg, 4, 16).
inline_builtin(stat_flag, 2,  17).
inline_builtin(stat_set_flag, 3, 18).
inline_builtin(buff_alloc, 3, 19).
inline_builtin(buff_word, 3, 20).
inline_builtin(buff_set_word, 3, 21).
inline_builtin(buff_byte, 3, 22).
inline_builtin(buff_set_byte, 3, 23).
inline_builtin(code_call, 3, 24).
inline_builtin(str_len, 2, 25).
inline_builtin(str_cpy, 2, 26).
inline_builtin(str_cat, 3, 27).
inline_builtin(str_cmp, 3, 28).
inline_builtin(str_hsh, 4, 29).
inline_builtin(str_insert, 2, 30).
inline_builtin(stat_sta, 1, 32).
inline_builtin(stat_cputime, 1, 33).
inline_builtin(code_load, 3, 34).
inline_builtin(buff_set_var, 4, 35).
inline_builtin(buff_dealloc, 4, 36).
inline_builtin(buff_cell, 3, 37).
inline_builtin(buff_set_cell, 4, 38).

inline_builtin(file_getword, 2, 40).
inline_builtin(file_putword, 2, 41).
inline_builtin(psc_insert, 4, 42).
inline_builtin(psc_import, 3, 43).
inline_builtin(file_getbuf, 4, 44).
inline_builtin(file_putbuf, 4, 45).
inline_builtin(psc_insertmod, 3, 46).
inline_builtin(load_seg, 5, 47).
inline_builtin(file_gettoken, 5, 48).
inline_builtin(file_puttoken, 3, 49).
inline_builtin(term_hash, 3, 50).
inline_builtin(unload_seg, 1, 51).
inline_builtin(load_obj, 4, 52).
inline_builtin(expand_file_name, 2, 53).
inline_builtin(getenv, 2, 54).
/* inline_builtin(sys_syscall, 4, 55). */
inline_builtin(sys_system, 2, 56).
inline_builtin(sys_gethost, 2, 57).
inline_builtin(sys_errno, 1, 58).
inline_builtin(sys_brocall, 3, 59).
inline_builtin(file_time, 2, 60).

/* Domain stuff taken out for now (Kostis 4/4/93)
inline_builtin(dom_size, 2, 80).
inline_builtin(dom_type, 2, 81).
inline_builtin(dom_range, 3, 82).
inline_builtin(dom_elem, 2, 83).
inline_builtin(dom_diff, 3, 84).
inline_builtin(dom_plus, 3, 85).
inline_builtin(dom_times, 3, 86).
inline_builtin(dom_min, 2, 87).
inline_builtin(dom_enum, 2, 88).
inline_builtin(dom_esize, 2, 89).
 */

inline_builtin(buff_assign_word, 3, 96).

inline_builtin(psc_env, 2, 100).
inline_builtin(psc_spy, 2, 101).
inline_builtin(psc_tabled, 2, 102).
inline_builtin(tip_prop, 2, 103).
inline_builtin(is_incomplete, 2, 104).

inline_builtin(pair_psc, 2, 110).
inline_builtin(pair_next, 2, 111).
inline_builtin(next_bucket, 2, 112).

inline_builtin(heap_copyterm, 2, 115).
inline_builtin(tab_intern, 2, 116).
inline_builtin(is_xwammode, 1, 117).
inline_builtin(close_open_tables, 0, 118).
inline_builtin(call_hash, 5, 119).
inline_builtin(print_predicate_table, 1, 120).
inline_builtin(analyze_predicate_table, 1, 124).
inline_builtin(comp_code_call, 2, 125).
inline_builtin(abolish_table_info, 0, 126).

/*======================================================================*/
/* builtin functions							*/
/*======================================================================*/

builtin_function('+', 2, 1).
builtin_function('-', 2, 2).
builtin_function('*', 2, 3).
builtin_function('/', 2, 4).
builtin_function('/\', 2, 5).
builtin_function('\/', 2, 6).
builtin_function('//', 2, 7).
builtin_function(sin, 1, 9).
builtin_function(cos, 1, 10).
builtin_function(tan, 1, 11).
builtin_function(float, 1, 13).
builtin_function(floor, 1, 14).
builtin_function(exp, 1, 15).
builtin_function(log, 1, 16).
builtin_function(log10, 1, 17).
builtin_function(sqrt, 1, 18).
builtin_function(asin, 1, 19).
builtin_function(acos, 1, 20).
builtin_function(atan, 1, 21).

