/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  compile.H
  Author(s)		:  Saumya Debray, Kostis F. Sagonas,
			   Terrance Swift, David S. Warren
  Modified by		:  Jiyang Xu, David S. Warren, Kostis F. Sagonas
  Last modification	:  June 12, 1993
========================================================================*/

:- export compile/4, mc/2, abort_if_syntax_errors/1. 
:- export 'table #'/0, 'error occurred'/0.

:- import cp_opt/2 from cp_opt.
:- import flatten/2 from flatten.
:- import str_cat/3 from machine.
:- import abort/0 from interpreter.
:- import useinfer/3 from useinfer.
:- import define_table/1 from tabdef.
:- import standard_symbol/3 from std_sbp.
:- import build_graph/1 from build_graph.
:- import print_result/1 from printresult.
:- import 'syntax errors'/0 from file_read.
:- import parse/4, get_symtab/2 from parse.
:- import force_inprog_loaded/0 from inprog.
:- import force_tp_var_loaded/0 from tp_var.
:- import force_tp_eval_loaded/0 from tp_eval.
:- import force_tp_goal_loaded/0 from tp_goal.
:- import asm_genheader/4, asm_PIL/4 from asm.
:- import force_varproc_loaded/0 from varproc.
:- import force_asm_opt_loaded/0 from asm_opt.
:- import force_asm_inst_loaded/0 from asm_inst.
:- import force_asm_pass2_loaded/0 from asm_pass2.
:- import tell/1, cputime/1, '\=='/2 from standard.
:- import force_tp_geninline_loaded/0 from tp_geninline.
:- import force_tprog_loaded/0, compile_clause/5 from tprog.
:- import force_tp_index_loaded/0, makeindex/7 from tp_index.
:- import force_preprocess_loaded/0, preprocess/3 from preprocess.
:- import write_asmheader/4, write_asm_instructions/1 from writeasm.
:- import force_peephole_loaded/0, compile_peephole_opt/2 from peephole.
:- import sym_name/3, sym_type/2, sym_prop/2, sym_complete/1 from symtab.
:- import message/1, warning/1, error/1, time_message/2, setoptions/1, option/1
     from aux.
:- import prepare/0, member/2, gennum/1, myclose/1, conget/2, conset/2, system/1
     from prof_sbp.

