/************************************************************************/
/*                                                                      */
/* XSB System                                                           */
/* Copyright SUNY at Stony Brook, 1986, ECRC 1990                       */
/* Copyright (C) SUNY at Stony Brook, 1993                              */
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB, */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along   */
/* with XSB so you can know your rights and responsibilities.           */
/* It should be in a file named LICENSE.                                */
/* Among other things, this notice must be preserved on all copies.     */
/*                                                                      */
/************************************************************************/

/*======================================================================
  File			:  unify.i
  Author(s)		:  David S. Warren, Terrance Swift, Jiyang Xu
  Modified by		:  Kostis F. Sagonas
  Last modification	:  July 1993
========================================================================*/


    DEREF(op1, nunify_l0)
    /* case FREE: */
	IFTHENELSE_DEREF(op2, nunify_l1)	
	    /* op2 is FREE 			free  ... free */
		if ( (CPtr)(op1) != (CPtr)(op2) ) {
		    if ( (CPtr)(op1) < (CPtr)(op2) ) {
			if ( (CPtr)(op1) < hreg )  /* op1 not in loc stack */
			    {bind_ref((CPtr)(op2), (CPtr)(op1));}
			else  /* op1 points to op2 */
			    {bind_ref((CPtr)(op1), (CPtr)(op2));}
             /* doc tls -- extra garbage because stacks point in diff dirs. */
		    }
		    else { /* op1 > op2 */
			if ( (CPtr)(op2) < hreg ) 
			    {bind_ref((CPtr)(op1), (CPtr)(op2));}
			else
			    {bind_ref((CPtr)(op2), (CPtr)(op1));}
		    }
		}
		IFTHEN_SUCCEED;
	}
	else 
#ifdef DOMAIN
	     if (cell_tag(op2) != DVAR)
	     /* op2 is DELAY, STRING, FLOAT, CS, LIST, or INT.	*/
#endif
	     {	bind_copy0((CPtr)(op1), op2);
		IFTHEN_SUCCEED;
	     }
#ifdef DOMAIN
	     else { 
		if (*((CPtr)domain_val(op2))!=op2) {
		     op2 = *((CPtr)domain_val(op2));
		     goto nunify_l1;
		}
		bind_copy0((CPtr)(op1), op2);
		IFTHEN_SUCCEED;
	     }
#endif
	break; /* for op1=free */

    case CS: /* op1=c/s */
	IFTHENELSE_DEREF(op2, nunify_l2)
	    /* op2 is FREE		c/s ... free */
		bind_copy0((CPtr)(op2), op1);
	        IFTHEN_SUCCEED;
	}
	else if (isconstr(op2) /* || isdelay(op2) */ ) {
        	if (op1 != op2) {  /* a != b */
		    op1 = (Cell)(clref_val(op1));
		    op2 = (Cell)(clref_val(op2));
		    if (((Pair)(CPtr)op1)->psc_ptr!=((Pair)(CPtr)op2)->psc_ptr){
						/* 0(a) != 0(b) */
			IFTHEN_FAILED;
		    } else {
	               arity = get_arity(((Pair)(CPtr)op1)->psc_ptr);
        	       for ( i=1; i <= arity;  i++ ) {
			 if(!unify(*((CPtr)op1+i), *((CPtr)op2+i))) {
			     IFTHEN_FAILED; 
			 }
		       }
		    }
		}
		IFTHEN_SUCCEED;
	      }
	      else { /* op2 is DVAR, STRING, FLOAT, LIST, or INT.	*/
		IFTHEN_FAILED;
	      }
	break;   /* for op1=c/s */

    case LIST:	/* op1=list */
	IFTHENELSE_DEREF(op2, nunify_l3)
	    /* op2 is FREE			   list ... free */
		bind_copy0((CPtr)(op2), op1);
		IFTHEN_SUCCEED;
	}
	else if (islist(op2)) {	/* list ... list */
		if (op1 != op2) {
		    op1 = (Cell)(clref_val(op1));
		    op2 = (Cell)(clref_val(op2));
		    if ( !unify(*((CPtr)op1), *((CPtr)op2))
		             || !unify(*((CPtr)op1+1), *((CPtr)op2+1)) ) {
			  IFTHEN_FAILED;
		    }
		}
		IFTHEN_SUCCEED;
	     }
	     else { IFTHEN_FAILED; }
	break; /* op1=list */

    case INT:	/* op1=num */
	IFTHENELSE_DEREF(op2, nunify_l4)
	    /* op2 is FREE:			   num ... free */
		bind_copy0((CPtr)(op2), op1);
		IFTHEN_SUCCEED;
	}
	else if (isinteger(op2)) { 	/* or isdelay(op2) */
	    	/* num ... num */
		if (numequal(op2, op1)) {IFTHEN_SUCCEED;} else {IFTHEN_FAILED;}
	     }
	     else	/* op2 is FLOAT, STRING, CS, or	LIST.	*/
#ifdef DOMAIN
	          if (cell_tag(op2) != DVAR)
#endif
		  { IFTHEN_FAILED; }
#ifdef DOMAIN
		  else { printf("DVAR\n"); exit(0); }
#endif
	break; /* op1=int */

    case STRING:	/* op1=string */
	IFTHENELSE_DEREF(op2, nunify_l5)
	    /* op2 is FREE			   string ... free */
		bind_copy0((CPtr)(op2), op1);
		IFTHEN_SUCCEED;
	}
	else if (isstring(op2)) {
		if (string_val(op2)==string_val(op1)) {IFTHEN_SUCCEED;}
		else {IFTHEN_FAILED;}
	     }
	     else	/* op2 is INT, FLOAT, CS, or LIST.	*/
#ifdef DOMAIN
	          if (cell_tag(op2) != DVAR)
#endif
		  { IFTHEN_FAILED; }
#ifdef DOMAIN
		  else { printf("DVAR\n"); exit(0); }
#endif
	break; /* op1=string*/

    case FLOAT:
	IFTHENELSE_DEREF(op2, nunify_l6)
	    /* op2 is FREE			   float ... free */
		bind_copy0((CPtr)(op2), op1);
		IFTHEN_SUCCEED;
	}
	else if (isfloat(op2)) {	/* or isdelay(op2) */
/*		if (float_val(op1)==float_val(op2)) {IFTHEN_SUCCEED;}
		else {IFTHEN_FAILED;}	*/
		unify_float_unification_exception;
		IFTHEN_FAILED;
	     }
	     else	/* op2 is STRING, INT, CS, or LIST.	*/
#ifdef DOMAIN
	          if (cell_tag(op2) != DVAR)
#endif
		  { IFTHEN_FAILED; }
#ifdef DOMAIN
		  else { 
			 if (*((CPtr)domain_val(op2))!=op2) {
		  	    op2 = *((CPtr)domain_val(op2));
			    goto nunify_l6;
			 }
			 IFTHEN_FAILED;
		  }
#endif
	break; /* op1=float */

#ifdef DOMAIN
    case DVAR: { printf("DVAR\n"); exit(0); }
#endif	/* op1=dvar */

/*  case DELAY: */

    DREND
