/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  map.P
  Author(s)		:  Jiyang Xu, Kostis Sagonas
  Last modification	:  April 12, 1993
========================================================================*/


go :- cputime(T0), ( map(_), fail; true), cputime(T1),
	T is T1 - T0, write('Time used: '), write(T), write('  sec'), nl.

demo :- cputime(T0), ( map(Map), write_res(Map), fail; true), cputime(T1),
	T is T1 - T0, write('Time used: '), write(T), write('  sec'), nl.


map( Map ) :-
        map_outline( Map ),
        colour_map( Map, [red, green, blue, white] ).


map_outline( [ country(a,A,[B,C,D]),     country(b,B,[A,C,E]),
               country(c,C,[A,B,D,E,F]), country(d,D,[A,C,F]),
               country(e,E,[B,C,F]),     country(f,F,[C,D,E])
             ] ).

colour_map( [Country|Map], ColoursList ) :-
        colour_country( Country, ColoursList ),
        colour_map( Map, ColoursList ).
colour_map( [], _ ).

colour_country( country(_,C,AdjacentCountries), ColoursList ) :-
        delete( C, ColoursList, ColoursList1 ),
        subset( AdjacentCountries, ColoursList1 ).

subset( [C|Cs], ColoursList ) :-
        delete( C, ColoursList, _ ),
        subset( Cs, ColoursList ).
subset( [], _ ).

delete( Element, [First|List], [First|MoreList] ) :-
        delete( Element, List, MoreList ).
delete( Element, [Element|List], List ).

write_res([]) :- nl.
write_res([country(Country, Color, _)|Rest]) :-
	write(Country), write('='), write(Color), write(' '),
	write_res(Rest).

