/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  ptqlex.P
  Author(s)		:  David S. Warren
  Last modification	:  April 12, 1993
========================================================================*/

% The PTQ lexicon

:- export lex/3.

% lex(Cat,Word,Attr).
lex(det,a,_).
lex(det,the,_).
lex(det,every,_).

lex(pro,him,gc(m,obj)).
lex(pro,he,gc(m,sub)).
lex(pro,her,gc(f,obj)).
lex(pro,she,gc(f,sub)).
lex(pro,it,gc(n,_)).

lex(biv,runs,p(s,run)).
lex(biv,run,p(i,run)).
lex(biv,walks,p(s,walk)).
lex(biv,walk,p(i,walk)).
lex(biv,talks,p(s,talk)).
lex(biv,talk,p(i,talk)).
lex(biv,rises,p(s,rise)).
lex(biv,rise,p(i,rise)).

lex(bte,john,m).
lex(bte,bill,m).
lex(bte,mary,f).
lex(bte,ninety,n).

lex(btv,finds,p(s,find)).
lex(btv,find,p(i,find)).
lex(btv,loses,p(s,lose)).
lex(btv,lose,p(i,lose)).
lex(btv,eats,p(s,eat)).
lex(btv,eat,p(i,eat)).
lex(btv,loves,p(s,love)).
lex(btv,love,p(i,love)).
lex(btv,dates,p(s,date)).
lex(btv,date,p(i,date)).
lex(btv,is,p(s,be)).
lex(btv,be,p(i,be)).
lex(btv,seeks,p(s,seek)).
lex(btv,seek,p(i,seek)).
lex(btv,conceives,p(s,conceive)).
lex(btv,conceive,p(i,conceive)).

%btt(necessarily) --> word(necessarily). % wrong

lex(bcn,man,m).
lex(bcn,woman,f).
lex(bcn,park,n).
lex(bcn,fish,n).
lex(bcn,pen,n).
lex(bcn,unicorn,n).
lex(bcn,price,n).
lex(bcn,temperature,n).

lex(biav,rapidly,_).
lex(biav,slowly,_).
lex(biav,voluntarily,_).
lex(biav,allegedly,_).

lex(pr,in,_).
lex(pr,about,_).

lex(bivt,[believes,that],p(s,believe_that)).
lex(bivt,[believe,that],p(i,believe_that)).
lex(bivt,[asserts,that],p(s,assert_that)).
lex(bivt,[assert,that],p(i,assert_that)).

lex(biviv,[tries,to],p(s,try_to)).
lex(biviv,[try,to],p(i,try_to)).
lex(biviv,[wishes,to],p(s,wish_to)).
lex(biviv,[wish,to],p(i,wish_to)).

