/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  qsort.P
  Author(s)		:  Jiyang Xu, Kostis Sagonas
  Last modification	:  April 12, 1993
========================================================================*/

:- export demo/0, qsort/2.

/* time for compiling this module (naive qsort without if-then-else):

	Sepia 2.12a:		2.03 sec (2.33 before loading lists.pl)
	SBProlog double -O:	3.10 sec (5.22 before loading )
	XSB (optimized):	0.53 seconds

*/

demo :- qsort([3,5,6,2,7,1], R), write(R).

qsort([X|T],R) :-
	part(X,T,U1,U2),
	qsort(U1,V1),
	qsort(U2,V2),
	append(V1,[X|V2],R).
qsort([],[]).

part(M,[E1|T],[E1|U1],U2) :-
	E1 =< M, part(M,T,U1,U2).
part(M,[E1|T],U1,[E1|U2]) :-
	E1 > M, part(M,T,U1,U2).
part(_,[],[],[]).

append([],X,X).
append([H|L1],L2,[H|L3]) :- append(L1,L2,L3).

