/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  shortest_path.P
  Author(s)		:  David S. Warren
  Last modification	:  April 12, 1993
========================================================================*/

/* Experimentation with shortest path, using table builtins. */

:- import subsumes_chk/2 from subsumes.
:- import get_calls_for_table/3, get_returns_for_call/2 from tables.

:- table(sp/3).

demo :-
	sp(a,X,C),
	write('Best cost so far from a to '),write(X),write(' is '),writeln(C),fail.
demo.

sp(X,Y,C) :- 
	dist(X,Y,C),
	none_better(X,Y,C).
sp(X,Y,C) :-
	sp(X,Z,C1),
	none_better(X,Z,C1),
	dist(Z,Y,C2),
	C is C1+C2,
	none_better(X,Y,C).


none_better(X,Y,C) :-
	get_calls_for_table(sp(X,_,_),Call,_Empty),
	subsumes_chk(Call,sp(X,Y,_)),
	!,
	\+ (	get_returns_for_call(Call,Ret),
		Ret = sp(X,Y,C1),
		C1 < C
	).

dist(a,d,2).
dist(a,b,5).
dist(a,c,3).
dist(c,b,1).
dist(b,e,3).
dist(b,d,4).
dist(e,d,2).
dist(d,b,1).
