/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
   File			:  delaylib.P
   Author(s)		:  Jiyang Xu
   Modified by		:  Jiyang Xu
   Last modification	:  August 13, 1990
========================================================================*/


:- export solve_wakengoals/0, print_delaygoals/0.

:- import stat_flag/2, stat_set_flag/3, buff_word/3, buff_assign_word/3,
	buff_cell/3, psc_prop/2, psc_type/2, term_psc/2, code_call/3,
	file_put/2
    from machine.
:- import file_write/2 from file_write.

solve_wakengoals :- 
	stat_flag(25, WakenGoals),
	( WakenGoals =:= 0 -> true
	; call_delayed(WakenGoals),
	  solve_wakengoals
	).

call_delayed(WakenGoals) :-
	buff_word(WakenGoals, 8, Next),
	stat_set_flag(25, Next, 1),
	buff_word(WakenGoals, 0, Solved),
	( Solved =:= 2 -> true
	;   buff_assign_word(WakenGoals, 0, 2),
	    buff_cell(WakenGoals, 16, Call),
/* file_write(1, 'Waking: '), file_write(1, Call), file_put(1, 10), */
	    term_psc(Call, Psc),
	    psc_prop(Psc, Addr),
	    psc_type(Psc, T),
	    code_call(Addr, Call, T)	% code_call must be the last goal
	).

print_delaygoals :-
	stat_flag(26, DelayHead),
	buff_word(DelayHead, 8, Next),
	print_delaygoals(Next, DelayHead, 0).

print_delaygoals(Head, Head, _) :- !.
print_delaygoals(DGoal, Head, I) :-
	buff_cell(DGoal, 16, Term),
	file_put(1, 10),
	( I =:= 0 -> file_write(1, '     when ')
	; 	     file_write(1, '      and ')
	),
	file_write(1, Term),
	buff_word(DGoal, 8, Next),
	I1 is I + 1,
	print_delaygoals(Next, Head, I1).
