/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  debugger.H
  Author(s)		:  David S. Warren
  Modified by		:  Kostis F. Sagonas, Jiyang Xu
  Last modification	:  July 19, 1992
========================================================================*/


/* Trace and Debug package */

:- export debug/0, nodebug/0, dump/0, trace_stack_max/0, notrace_stack_max/0,
	  (spy)/1, (nospy)/1, trace/0, notrace/0, piltrace/0, hitrace/0,
	  nosimtrace/0, debugging/0.
:- export '_$deb_trace'/1, '_$deb_spy'/1.

:- import assert0/1 from assert.
:- import set_inthandler/2, abort/0, break/0 from interpreter.
:- import load_pred/1 from loader.
:- import file_write/2 from file_write.
:- import term_psc/2, psc_insert/4, stat_flag/2, stat_set_flag/3, 
	  psc_type/2, psc_prop/2, conpsc/2, file_get/2, file_put/2, 
	  buff_byte/3, buff_set_byte/3, conname/2, code_call/3,
	  psc_arity/2, psc_name/2, term_arg/3, term_type/2
     from machine.
:- import standard_symbol/3 from std_sbp.

% := hide debug/0.


/* --------------------- end of file debugger.H ----------------------- */
