/************************************************************************/
/*									*/
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1993				*/
/*									*/
/* Everyone is granted permission to copy, modify and redistribute XSB,	*/
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  hilog_symbol.P
  Author(s)		:  Kostis F. Sagonas
  Last modification	:  June 18, 1992
========================================================================*/


add_hilog_symbol(X) :- 
	var(X), 
	!, 
	abort('Uninstantiated argument 1 of hilog/1').
add_hilog_symbol([]) :- 
	!.
add_hilog_symbol([HS|HSs]) :- 
	!,
	add_hilog_symbol(HS), 
	add_hilog_symbol(HSs).
add_hilog_symbol((HS, HSs)) :-
	!, 
	add_hilog_symbol(HS),
	add_hilog_symbol(HSs).
add_hilog_symbol(HS) :- 
	'_$hilog_symbol'(HS),	% If it's already in there don't add it again!
	!.
add_hilog_symbol(HS) :- 
	( atom(HS) ->
		assertai('_$hilog_symbol'(HS), 1)
	; abort(('Symbol ', HS, ' in hilog declaration is not an atom')) ).


'_$hilog_symbol'('^~').


/* ----------------- end of file hilog_symbol.P ----------------------- */

