/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File				:  loader.H
  Author(s)			:  Kostis F. Sagonas, Jiyang Xu
  Modified by			:  Jiyang Xu (August 13, 1990)
  Made libpath/1 dynamic by	:  Kostis F. Sagonas (May 28, 1992)
  Last modification		:  April 3, 1993
========================================================================*/


:- export load_pred/1, load/1, libpath/1.

/*----------------------------------------------------------------------*/
/* The following import declarations are very strange! These `imported'	*/
/* predicates cannot be really imported. For them to be imported, the	*/
/* interpreter must be loaded, but the interpreter cannot be loaded	*/
/* unless these predicates are imported. (!?!?!?)			*/
/* So, the only predicates that can be imported in this file are calls	*/
/* to C functions. (in-line + builtin predicates). This explains why	*/
/* we use some `strange' predicates here like ll_nl/0, ll_prompt/1 etc.	*/
/* Thus, all of the following are compiled using "inlinebuiltin".	*/
/*----------------------------------------------------------------------*/

:- import term_type/2, term_psc/2, psc_name/2, psc_arity/2, psc_env/2,
	  psc_type/2, psc_prop/2, file_put/2, buff_byte/3, str_cat/3, 
	  code_call/3, code_load/3, stat_flag/2, stat_set_flag/3,
	  expand_file_name/2
     from machine.

:- import library_directory/1 from '.xsbrc'.

