/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  machine.H
  Author(s)		:  Kostis F. Sagonas, Jiyang Xu
			   David S. Warren, Terrance Swift
  Last modification	:  July, 1993
========================================================================*/


/*======================================================================*/
/* This file contains definitions for predicates implemented by the	*/
/* underline machine (hard builtins).					*/
/* Please keeo this format for easier diffing
/*======================================================================*/

:- export
	psc_name/2, 
	psc_arity/2, 
	psc_type/2, 
	psc_prop/2, 
	psc_set_type/3, 
	psc_set_prop/3,
	file_open/3, 
	file_close/1, 
	file_get/2, 
	file_put/2,
	term_psc/2, 
	term_type/2, 
	term_compare/3, 
	term_new/2,
	term_arg/3, 
	term_set_arg/4, 
	term_hash/3,
	stat_flag/2, 
	stat_set_flag/3, 
	stat_sta/1,
	buff_alloc/3, 
	buff_word/3, 
	buff_set_word/3,
	buff_dealloc/4, 
	buff_cell/3, 
	buff_set_cell/4, 
	buff_set_var/4,
	buff_byte/3, 
	buff_set_byte/3, 
	file_puttoken/3,
	code_call/3, 
	code_load/2, 
	code_load/3, 
	load_seg/5, 
	file_gettoken/5,
	stat_cputime/1, 
	file_getword/2, 
	file_putword/2, 
	str_insert/2,
	psc_insert/4, 
	psc_import/3, 
	psc_insertmod/3,
	file_getbuf/4, 
	file_putbuf/4,
	str_len/2, 
	str_cpy/2, 
	str_cat/3, 
	str_cmp/3, 
	str_hsh/4,
	unload_seg/1, 
	load_obj/4, 
	expand_file_name/2, 
	getenv/2, 
	sys_syscall/4,
	sys_system/2, 
	sys_gethost/2, 
	sys_errno/1, 
	sys_brocall/3, 
	file_time/2,
%	dom_size/2, dom_type/2, dom_range/3, dom_elem/2, dom_diff/3,
%	dom_plus/3, dom_times/3, dom_min/2, dom_enum/2, dom_esize/2,
	buff_assign_word/3,
 	psc_env/2, 
	psc_spy/2, 
	psc_tabled/2, 
	tip_prop/4,
	is_incomplete/2,
	get_osp_breg/2,
	cut_if_leader/3,
	pair_psc/2, 
	pair_next/2, 
	next_bucket/2,
	suspend/3, 
	incomplete/2, 
	heap_copyarg/2, 
	table_intern/2,
	is_xwammode/1, 
	close_open_tables/0, 
	call_hash/5,
	print_predicate_table/1, 
	analyze_predicate_table/1,
	comp_code_call/2, 
	abolish_table_info/0,
	zero_out_profile/0, 
	write_out_profile/0,
	assert_code_to_buff/2,
	assert_buff_to_clref/7,
	fmt_write/3,
	fmt_read/5.

:- export 
	fmt_read/4, fmt_write/2,
	psc_insert/3, conname/2, conpsc/2, is_integer/1, 
	machine_file_exists/1, backtrackable_buff_set_word/4.

/* --------------------- end of file machine.H ------------------------ */
