/************************************************************************/
/*                                                                      */
/* XSB System								*/
/* Copyright (C) SUNY at Stony Brook, 1986, 1993; ECRC, 1990		*/
/*                                                                      */
/* Everyone is granted permission to copy, modify and redistribute XSB  */
/* but only under the conditions described in the XSB Licence Agreement.*/
/* A copy of this license is supposed to have been given to you along	*/
/* with XSB so you can know your rights and responsibilities.		*/
/* It should be in a file named LICENSE.				*/
/* Among other things, this notice must be preserved on all copies.	*/
/*									*/
/************************************************************************/

/*======================================================================
  File			:  standard.H
  Author(s)		:  Kostis F. Sagonas, Jiyang Xu 
  Expanded for HiLog by	:  Kostis F. Sagonas
  Last modification	:  April 2, 1993
========================================================================*/


/* ------------------------------ */
/*  exported built-in predicates  */
/* ------------------------------ */


:- export 
	arg/3,		arg0/3,		atom/1,		atomic/1,
	cputime/1,	call/1,		call_expose/1,	callable/1,
	close/1,	compare/3,	compound/1,	display/1,
	expand_term/2,	file_exists/1,	fail/0,		fail_if/1,
	fileerrors/0,	float/1,	(fun)/1,	functor/3,
	get/1,		get0/1,		halt/0,		
	(hilog)/1,	hilog_arg/3,	hilog_functor/3,hilog_op/3,
	(index)/3,	(table)/3,
	integer/1,	is/2,		is_list/1,	proper_hilog/1,
	listing/0,	listing/1,	name/2,		nl/0,
	nofileerrors/0, nonvar/1,	(not)/1,	number/1,
	once/1,		op/3,		otherwise/0,
	print/1,	put/1,
	read/1,		real/1,		repeat/0,
	see/1,		seeing/1,	seen/0,
	skip/1,		statistics/1,	statistics/0,	structure/1,
	tab/1,		tell/1,		telling/1,	told/0,
	ttywrite/1,	ttywritenl/1,
	true/0, 	var/1,		
	write/1,	writeln/1,	write_prolog/1,	writeq/1,
	write_canonical/1, alt_write_canonical/1,
	('\+')/1,	'=:='/2,	'=\='/2,	'<'/2,
	'>'/2,		'=<'/2,		'>='/2,		'='/2,		'\='/2,
	'=..'/2,	'^=..'/2,	'=='/2,		'\=='/2,
	'@<'/2,		'@>'/2,		'@=<'/2,	'@>='/2,
	';'/2,		','/2,		'->'/2,
	'_$cutto'/1,	'_$savecp'/1.	


/* --------------------------------------------------------------- */
/*  exported predicates used in other modules (but not built-ins)  */
/* --------------------------------------------------------------- */

:- export
	call_c/1,	goal_cut_trans/3,	goal_cut_untrans/2,
	warning/1,	abort/1, 
	arity_integer/1.


/* The following predicates are directly imported from other modules */

:- import file_put/2, psc_set_prop/3, psc_insert/3, psc_name/2,
	  term_psc/2, term_arg/3, psc_arity/2, term_type/2, psc_prop/2,
	  term_new/2, file_open/3, psc_type/2, stat_set_flag/3, file_close/1,
	  file_get/2, stat_flag/2, psc_set_type/3, term_compare/3,
	  stat_sta/1, conname/2, conpsc/2, stat_cputime/1, code_call/3,
	  expand_file_name/2, machine_file_exists/1, psc_insert/4
     from machine.
:- import load_pred/1 from loader.
:- import str_tolist/2, str_fromlist/2 from string.
:- import file_write0/2, file_write/2, file_write_prolog/2, 
	  file_write_quoted/2, file_write_canonical/2, 
	  alt_file_write_canonical/2     from file_write.
:- import char_blank/1 from file_readtoken.
:- import file_read/2 from file_read.
:- import eval/2 from eval.
:- import abort/0 from interpreter.
:- import '_$op'/3, add_ops/3, op_priority/1, op_specifier/1, add_index/3,
	add_table/3 from file_op.
:- import '_$hilog_symbol'/1, add_hilog_symbol/1 from hilog_symbol.
:- import dcg/2 from dcg.
%%:- import term_expansion/2 from term_expansion.
:- import clause/2 from assert.
:- import numbervars/1 from numbervars.
:- import predicate_property/2 from current_symbols.

/* --------------------- end of file standard.H ----------------------- */
